﻿// <auto-generated />
using System;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Migrations;
using Microsoft.EntityFrameworkCore.Storage.ValueConversion;
using Npgsql.EntityFrameworkCore.PostgreSQL.Metadata;
using PartyServices.Domain.Contexts;

#nullable disable

namespace PartyServices.Domain.Migrations
{
    [DbContext(typeof(PartyServicesContext))]
    [Migration("20241114152313_AddedCitizensAndHouseholds")]
    partial class AddedCitizensAndHouseholds
    {
        /// <inheritdoc />
        protected override void BuildTargetModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .HasAnnotation("ProductVersion", "8.0.0")
                .HasAnnotation("Relational:MaxIdentifierLength", 63);

            NpgsqlModelBuilderExtensions.UseIdentityByDefaultColumns(modelBuilder);

            modelBuilder.Entity("PartyServices.Domain.Contexts.Models.Account", b =>
                {
                    b.Property<Guid>("Uuid")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("uuid")
                        .HasColumnName("uuid");

                    b.Property<string>("AccountHolder")
                        .IsRequired()
                        .HasColumnType("text")
                        .HasColumnName("account_holder");

                    b.Property<string>("Iban")
                        .IsRequired()
                        .HasColumnType("text")
                        .HasColumnName("iban");

                    b.HasKey("Uuid");

                    b.ToTable("accounts");
                });

            modelBuilder.Entity("PartyServices.Domain.Contexts.Models.Address", b =>
                {
                    b.Property<Guid>("Uuid")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("uuid")
                        .HasColumnName("uuid");

                    b.Property<string>("City")
                        .IsRequired()
                        .HasColumnType("text")
                        .HasColumnName("city");

                    b.Property<string>("HouseNumber")
                        .IsRequired()
                        .HasColumnType("text")
                        .HasColumnName("house_number");

                    b.Property<string>("PostalCode")
                        .IsRequired()
                        .HasColumnType("text")
                        .HasColumnName("postal_code");

                    b.Property<string>("Street")
                        .IsRequired()
                        .HasColumnType("text")
                        .HasColumnName("street");

                    b.HasKey("Uuid");

                    b.ToTable("addresses");
                });

            modelBuilder.Entity("PartyServices.Domain.Contexts.Models.Citizen", b =>
                {
                    b.Property<Guid>("Uuid")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("uuid")
                        .HasColumnName("uuid");

                    b.Property<Guid>("AddressId")
                        .HasColumnType("uuid")
                        .HasColumnName("address_id");

                    b.Property<long?>("BirthDate")
                        .HasColumnType("bigint")
                        .HasColumnName("birth_date");

                    b.Property<int>("Bsn")
                        .HasColumnType("integer")
                        .HasColumnName("bsn");

                    b.Property<string>("Email")
                        .HasColumnType("text")
                        .HasColumnName("email");

                    b.Property<long?>("EndDate")
                        .HasColumnType("bigint")
                        .HasColumnName("end_date");

                    b.Property<string>("FirstNames")
                        .IsRequired()
                        .HasColumnType("text")
                        .HasColumnName("first_names");

                    b.Property<string>("HhbNumber")
                        .IsRequired()
                        .HasColumnType("text")
                        .HasColumnName("hhb_number");

                    b.Property<Guid>("HouseHoldId")
                        .HasColumnType("uuid")
                        .HasColumnName("household_id");

                    b.Property<string>("Infix")
                        .IsRequired()
                        .HasColumnType("text")
                        .HasColumnName("infix");

                    b.Property<string>("Initials")
                        .IsRequired()
                        .HasColumnType("text")
                        .HasColumnName("initials");

                    b.Property<string>("PhoneNumber")
                        .HasColumnType("text")
                        .HasColumnName("phone_number");

                    b.Property<long>("StartDate")
                        .HasColumnType("bigint")
                        .HasColumnName("start_date");

                    b.Property<string>("Surname")
                        .IsRequired()
                        .HasColumnType("text")
                        .HasColumnName("surname");

                    b.Property<bool>("UseSaldoAlarm")
                        .HasColumnType("boolean")
                        .HasColumnName("use_saldo_alarm");

                    b.HasKey("Uuid");

                    b.HasIndex("AddressId")
                        .IsUnique();

                    b.HasIndex("HouseHoldId");

                    b.ToTable("citizens");
                });

            modelBuilder.Entity("PartyServices.Domain.Contexts.Models.CitizenAccount", b =>
                {
                    b.Property<Guid>("CitizenId")
                        .HasColumnType("uuid")
                        .HasColumnName("citizen_id");

                    b.Property<Guid>("AccountId")
                        .HasColumnType("uuid")
                        .HasColumnName("account_id");

                    b.HasKey("CitizenId", "AccountId");

                    b.HasIndex("AccountId");

                    b.ToTable("citizen_accounts");
                });

            modelBuilder.Entity("PartyServices.Domain.Contexts.Models.Department", b =>
                {
                    b.Property<Guid>("Uuid")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("uuid")
                        .HasColumnName("uuid");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasColumnType("text")
                        .HasColumnName("name");

                    b.Property<Guid>("OrganisationUuid")
                        .HasColumnType("uuid")
                        .HasColumnName("organisation_uuid");

                    b.Property<string>("PostadressenIds")
                        .IsRequired()
                        .HasColumnType("text")
                        .HasColumnName("postadressen_ids");

                    b.Property<string>("RekeningenIds")
                        .IsRequired()
                        .HasColumnType("text")
                        .HasColumnName("rekeningen_ids");

                    b.HasKey("Uuid");

                    b.HasIndex("OrganisationUuid");

                    b.ToTable("departments");
                });

            modelBuilder.Entity("PartyServices.Domain.Contexts.Models.DepartmentAccount", b =>
                {
                    b.Property<Guid>("DepartmentId")
                        .HasColumnType("uuid")
                        .HasColumnName("department_id");

                    b.Property<Guid>("AccountId")
                        .HasColumnType("uuid")
                        .HasColumnName("account_id");

                    b.HasKey("DepartmentId", "AccountId");

                    b.HasIndex("AccountId");

                    b.ToTable("department_accounts");
                });

            modelBuilder.Entity("PartyServices.Domain.Contexts.Models.DepartmentAddress", b =>
                {
                    b.Property<Guid>("DepartmentUuid")
                        .HasColumnType("uuid")
                        .HasColumnName("department_uuid");

                    b.Property<Guid>("AddressUuid")
                        .HasColumnType("uuid")
                        .HasColumnName("address_uuid");

                    b.HasKey("DepartmentUuid", "AddressUuid");

                    b.HasIndex("AddressUuid")
                        .IsUnique();

                    b.ToTable("department_addresses");
                });

            modelBuilder.Entity("PartyServices.Domain.Contexts.Models.Household", b =>
                {
                    b.Property<Guid>("Uuid")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("uuid")
                        .HasColumnName("uuid");

                    b.HasKey("Uuid");

                    b.ToTable("households");
                });

            modelBuilder.Entity("PartyServices.Domain.Contexts.Models.Organisation", b =>
                {
                    b.Property<Guid>("Uuid")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("uuid")
                        .HasColumnName("uuid");

                    b.Property<string>("BranchNumber")
                        .IsRequired()
                        .HasColumnType("text")
                        .HasColumnName("branch_number");

                    b.Property<string>("KvkNumber")
                        .IsRequired()
                        .HasColumnType("text")
                        .HasColumnName("kvk_number");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasColumnType("text")
                        .HasColumnName("name");

                    b.HasKey("Uuid");

                    b.ToTable("organisations");
                });

            modelBuilder.Entity("PartyServices.Domain.Contexts.Models.Citizen", b =>
                {
                    b.HasOne("PartyServices.Domain.Contexts.Models.Address", "Address")
                        .WithOne("Citizen")
                        .HasForeignKey("PartyServices.Domain.Contexts.Models.Citizen", "AddressId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("PartyServices.Domain.Contexts.Models.Household", "Household")
                        .WithMany("Citizens")
                        .HasForeignKey("HouseHoldId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("Address");

                    b.Navigation("Household");
                });

            modelBuilder.Entity("PartyServices.Domain.Contexts.Models.CitizenAccount", b =>
                {
                    b.HasOne("PartyServices.Domain.Contexts.Models.Account", "Account")
                        .WithMany("CitizenAccounts")
                        .HasForeignKey("AccountId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("PartyServices.Domain.Contexts.Models.Citizen", "Citizen")
                        .WithMany()
                        .HasForeignKey("CitizenId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("Account");

                    b.Navigation("Citizen");
                });

            modelBuilder.Entity("PartyServices.Domain.Contexts.Models.Department", b =>
                {
                    b.HasOne("PartyServices.Domain.Contexts.Models.Organisation", "Organisation")
                        .WithMany("Departments")
                        .HasForeignKey("OrganisationUuid")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("Organisation");
                });

            modelBuilder.Entity("PartyServices.Domain.Contexts.Models.DepartmentAccount", b =>
                {
                    b.HasOne("PartyServices.Domain.Contexts.Models.Account", "Account")
                        .WithMany("DepartmentAccounts")
                        .HasForeignKey("AccountId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("PartyServices.Domain.Contexts.Models.Department", "Department")
                        .WithMany("Accounts")
                        .HasForeignKey("DepartmentId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("Account");

                    b.Navigation("Department");
                });

            modelBuilder.Entity("PartyServices.Domain.Contexts.Models.DepartmentAddress", b =>
                {
                    b.HasOne("PartyServices.Domain.Contexts.Models.Address", "Address")
                        .WithMany("Department")
                        .HasForeignKey("AddressUuid")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("PartyServices.Domain.Contexts.Models.Department", "Department")
                        .WithMany("Addresses")
                        .HasForeignKey("DepartmentUuid")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("Address");

                    b.Navigation("Department");
                });

            modelBuilder.Entity("PartyServices.Domain.Contexts.Models.Account", b =>
                {
                    b.Navigation("CitizenAccounts");

                    b.Navigation("DepartmentAccounts");
                });

            modelBuilder.Entity("PartyServices.Domain.Contexts.Models.Address", b =>
                {
                    b.Navigation("Citizen");

                    b.Navigation("Department");
                });

            modelBuilder.Entity("PartyServices.Domain.Contexts.Models.Department", b =>
                {
                    b.Navigation("Accounts");

                    b.Navigation("Addresses");
                });

            modelBuilder.Entity("PartyServices.Domain.Contexts.Models.Household", b =>
                {
                    b.Navigation("Citizens");
                });

            modelBuilder.Entity("PartyServices.Domain.Contexts.Models.Organisation", b =>
                {
                    b.Navigation("Departments");
                });
#pragma warning restore 612, 618
        }
    }
}
